using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.CompilerServices;

namespace CS_asynplex {
	abstract class AsynplexProcess {
		public string name { get; private set; }

		public AsynplexProcess(string name) {
			this.name = name;
		}

		protected void print(string message) {
			lock (Communication.printLock) {
				Console.WriteLine("{0}: {1}", name, message);
			}
		}

		protected void send(string receiver, string tag, object payload) {
			Communication.send(new Message(name, receiver, tag, payload));
		}

		protected Message receive() {
			return Communication.receive(name);
		}

		protected Message receive(string sender) {
			return Communication.receive(name, sender);
		}

		protected Message receive(string sender, string tag) {
			return Communication.receive(name, sender, tag);
		}
		
		public abstract void run();
	}
}
