#ifndef ASYNPLEXCONTROL_H
#define ASYNPLEXCONTROL_H

#include "common/sparse.h"
#include "invertprocessor.h"
#include <vector>
#include <pthread.h>
extern "C" {
	#include <cellmsg.h>
}

class AsynplexControl {
public:
	void runAsynplex(int numIterationProcesses, int m, int n, SparseMatrix & A, TYPE * b, TYPE * c, TYPE f);
	void waitForCompletion();
private:
	static void getDimensions(cellmsg_rpc_data * rpc);
	static void getIntArrays(cellmsg_rpc_data * rpc);
	static void getTypeArrays(cellmsg_rpc_data * rpc);
	int m;
	int n;
	int numNonzeroes; // in A
	int intBytes;
	int typeBytes;
	int * intArrays;
	TYPE * typeArrays;
	pthread_t invertProcessor;
	int numIterationProcesses;
};

#endif
