#ifndef MESSAGE_H
#define MESSAGE_H

typedef struct {
	const char * sender;
	const char * receiver;
	const char * tag;
	void * payload;
} Message;

typedef struct {
	int sender;			// Rank / SPE index (0-7) of sender
	int receiver;		// Rank / SPE index (0-7) of receiver
	int tag;			// Arbitrary nonnegative integer (not limited like CML's tags)
	int payloadSize;	// Size (in bytes) of 'payload' buffer 
	void * payload;		// The entire RPC buffer - expected to contain FIRST sender+receiver+tag+payloadSize, and THEN the actual message payload
} RpcMessage;

#endif
