#include "print.h"
#include <pthread.h>
#include <stdarg.h>

static pthread_mutex_t printLock;

void initPrintFromProcess() {
	pthread_mutex_init(&printLock, NULL);
}

// If processName is NULL, no prefix will be printed
void printFromProcess(const char * processName, const char * formatString, ...) {
	va_list args;
	pthread_mutex_lock(&printLock);
	if (processName)
		printf("%s: ", processName);
	va_start(args, formatString);
	vprintf(formatString, args);
	va_end(args);
	printf("\n");
	fflush(stdout);
	pthread_mutex_unlock(&printLock);
}
