#ifndef COLUMNSELECTIONMANAGER_H
#define COLUMNSELECTIONMANAGER_H

#include "common/SafeVector.h"

typedef enum {
	OTHER_SIDE, 
	UNSELECTED, 
	SELECTED, 
	REJECTED, 
	UNDEFINED
} VariableStatus;

typedef struct {
	VariableStatus status;
	int basisWhereStatusChanged;
} VariableInfo;

typedef struct {
	int unattractiveVariable;
	int basis;
	const char * processName;
	const char * tagToSend;
} QueuedVariableRequest;

class ColumnSelectionManager {
public:
	void setup(int m, int n);
	void run();
private:
	bool installAttractiveCandidates(const SafeVector<int> & newCandidates, int basisNumber);
	VariableInfo * variables;
	SafeVector<int> attractive;
	SafeVector<QueuedVariableRequest> queuedVariableRequests;
	int m;
	int n;
	int kc;
};

#endif
