#ifndef PAYLOADTYPES_H
#define PAYLOADTYPES_H

#include "../common/genericvectors.h"
#include "sparse.h"
#include <vector>

typedef struct {
	int leavingRow;
	int enteringCol;
} InvProcPivotPayload;

typedef struct {
	int leavingVar;
	int enteringVar;
	int basisNumber;
} ColSelPivotPayload;

typedef struct {
	int basisNumber;
	std::vector<int> attractiveVariables;
} AttractiveCandidatesMessage;

typedef struct {
	int var;
	int basisNumber;
} CandidateIsUnattractivePayload;

typedef struct {
	int basisNumber;
} ChuzrOfferPayload;

typedef struct {
	int accepted;
} ChuzrAcceptancePayload;

typedef struct {
	int leavingRow;
	int enteringCol;
	int fromBasis;
	SafeSparseVector primalStepDirection;
	SafeSparseVector dualStepDirection;
	TYPE primalStepLength;
	TYPE dualStepLength;
	std::vector<TYPE> newEtaFileValues;
	std::vector<int> newEtaFileRowIndices;
	int etaFileSizeDiff;
} BasisChangePayload;

#endif
