#!/usr/bin/python
from sys import stdin

class Row:
	label = None
	type = None
	values = None
	index = None
	def __init__(self, label, type, index):
		self.label = label
		self.type = type
		self.index = index
		self.values = {}
	def __str__(self):
		return self.label + " (" + self.type + "): " + str(self.values)

lines = []
for line in stdin:
	lines.append(line)

rows = {}
columnLabels = []
columnIndices = {}
i = 0
while i < len(lines):
	line = lines[i]
	i += 1
	if line[0] == ' ':
		pass
	else:
		header = line.strip()
		if header == "ROWS":
			rowIndex = 0
			while lines[i][0] == ' ':
				items = lines[i].split()
				row = Row(items[1].strip(), items[0].strip(), rowIndex)
				if row.type == "N":
					objectiveIndex = rowIndex
				rows[row.label] = row
				rowIndex += 1
				i += 1
			tableau = [None] * len(rows)
		elif header == "COLUMNS":
			columnIndex = -1
			while lines[i][0] == ' ':
				items = lines[i].split()
				lim = 2 if len(items) == 5 else 1
				columnLabel = items[0].strip()
				if not columnIndices.has_key(columnLabel):
					columnIndex += 1
					columnLabels.append(columnLabel)
					columnIndices[columnLabel] = columnIndex
				for j in xrange(lim):
					rowLabel = items[1 + j * 2].strip()
					value = float(items[2 + j * 2].strip())
					rows[rowLabel].values[columnLabel] = value
				i += 1
			for j in xrange(len(tableau)):
				tableau[j] = [0] * (len(columnLabels) + 1)
			for row in rows.values():
				for colLabel in row.values:
					tableau[row.index][columnIndices[colLabel]] = row.values[colLabel]
		elif header == "RHS":
			while lines[i][0] == ' ':
				items = lines[i].split()
				lim = 2 if len(items) == 5 else 1
				for j in xrange(lim):
					rowLabel = items[1 + j * 2].strip()
					value = float(items[2 + j * 2].strip())
					rowIndex = rows[rowLabel].index
					tableau[rowIndex][-1] = value
				i += 1

for row in rows.values():
	tab = tableau[row.index]
	if row.type == "G":
		for i in xrange(len(tab)):
			tab[i] = -tab[i]
	elif row.type == "E":
		tableau.append([-x for x in tab])
tmp = tableau[objectiveIndex]
tableau[objectiveIndex] = tableau[0]
tableau[0] = tmp

ti = 0
while ti < len(tableau):
	nonzero = 0
	for x in tableau[ti]:
		if x != 0:
			nonzero = 1
			break
	if not nonzero:
		tableau.pop(ti)
		ti -= 1
	ti += 1

print len(tableau), len(tableau[0])
for tab in tableau:
	for cell in tab:
		print cell,
	print
